public class PeopleMaker extends Server
{ private double meanInter;
  private Random mySecRandom;
  private Random myCusRandom;
  private Random myTimeRandom;
  private Random myExitsRandom; // where people go
  private double[] probs;
  private double cPercent; // the % of people that are going to customs
  private double s1Percent;
  private double s2Percent;
  private int numPeople; // number of people generated

  public PeopleMaker(double[] probs,Server[] linkedTo,String myName, EventList master,
                     long seederExit,double meanInter,long seedSec,
                     long seedCustom,double cPercent,long seedA,double s1Percent,double s2Percent)
  { super(linkedTo,myName,master,0,0);
    this.probs = probs;
    this.meanInter = meanInter;
    this.mySecRandom = new Random(seedSec); // security
    this.myCusRandom = new Random(seedCustom); // customs
    this.myTimeRandom = new Random(seedA); // inter-arrival time seed
    this.myExitsRandom = new Random(seederExit);
    this.eventMaster = master;
    this.cPercent = cPercent;
    this.s1Percent = s1Percent;
    this.s2Percent = s2Percent;
    this.numPeople = 0;
    this.linkedTo = linkedTo;
    d.w("Constructin' shit");
  }

  public void Run(int currentTime)
  {
    // adds an event occuring a random amount of time from the current time.  The event occurs at this server when the next person shows up


    boolean goingToCustoms = (myCusRandom.nextUniformInt(1,100) < (this.cPercent * 100));
    double timeOfArrival = currentTime + (int)(myTimeRandom.nextExp(this.meanInter));
    boolean whichSec = (mySecRandom.nextUniformInt(1,100) > (this.s1Percent * 100));

    this.eventMaster.addEvent((int)(timeOfArrival),this);

    int iWhichSec;
    if(whichSec)
    { iWhichSec = 1;
    }
    else
    { iWhichSec=0;
    }

    Person temp = new Person(Constants.SEC_NAMES[iWhichSec],goingToCustoms,currentTime);
    this.sendToLink(temp,currentTime);

    this.numPeople++;
    this.stats.setPeople(numPeople);

    //d.w("CurrentTime = " + currentTime);
  }

  public void sendToLink(Person who,int currentTime)
  { double randNum = ((double)this.myExitsRandom.nextUniformInt(1,100))/100;
    double total = 0;
    double lastTotal = 0;
    for(int x=0;x<this.probs.length;x++)
    { total += this.probs[x];
      if(randNum >= lastTotal && randNum <= total)
      { this.linkedTo[x].addPerson(who,currentTime);
      }
      lastTotal = total;
    }
  }

  public boolean Done()
  { return (this.numPeople >= Constants.MAX_PEOPLE);
  }
}