// this class represents a server the directly precedes a security checkpoint

public class PreSecurity extends Server
{
  /*
    pre: linkedTo is not null, master is not null,
    post: creates a PreSecurity object that is linked to at least one security
  */
  public PreSecurity(Server[] linkedTo,String myName, EventList master,long seederTime,double meanTime)
  { super(linkedTo,myName,master,seederTime,meanTime);
  }

  /*
    pre: who is not null
    post: sends this person off to the security destination they are fated to go to
  */
  protected void goToSecurity(Person who,int currentTime)
  { for(int x=0;x<this.linkedTo.length;x++)
    { if(this.linkedTo[x].getName() == who.getSecurityFate()) // if the current link we are looking at is the same as the security this person is going to...
      { this.linkedTo[x].addPerson(who,currentTime); // then we should send them there
      }
    }
  }
  /*
    This function is called by all Server.Run() statements, and handles where the person goes
    pre: who is not null
    post: the person has been sent to a security station
  */
  public void sendToLink(Person who,int currentTime)
  { goToSecurity(who,currentTime);
  }
}